﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.IO;
using System.Linq;
using System.Reflection;
using System.Runtime.CompilerServices;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Media;

namespace WriteErase.ClassBase
{
    public partial class Product: INotifyPropertyChanged
    {
        public string img
        {
            get
            {
                string appDir = Path.GetDirectoryName(Assembly.GetExecutingAssembly().Location);//полный путь для проверки наличия файла
                appDir = appDir.Replace("\\bin\\Debug", "").Replace("\\bin\\Release", ""); ;//убираем все лишнее из пути
                string absolute_path = "\\Assets\\image\\" + ProductArticleNumber.ToUpper() + ".jpg";
                if (File.Exists(appDir + absolute_path))//проверка существования файла
                {
                    return absolute_path;
                }
                return "\\Assets\\picture.png";
            }
        }

        public double Cost
        {
            get
            {
                if (ProductDiscountMax > 0)
                    return (double)ProductCost * (1 - (double)ProductDiscountMax/ 100);
                else
                    return (double)ProductCost;
            }
        }

        public System.Windows.Visibility VisibilityCost
        {
            get => ((double)ProductDiscountMax > 0)? Visibility.Visible : Visibility.Collapsed;
        }

        public SolidColorBrush ViewColor
        {
            get => ((double)ProductDiscountMax > 15) ? new SolidColorBrush((Color)ColorConverter.ConvertFromString("#7fff00")) : new SolidColorBrush(Colors.White);
        }
        private int countProduct = 0;
        public int CountProduct { get => countProduct; set { countProduct = value; OnPropertyChanged(); } }

        public event PropertyChangedEventHandler PropertyChanged;
        public void OnPropertyChanged([CallerMemberName] string prop = "")
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(prop));
        }
    }
}
